/*
 * ReadWriteString.c
 *
 * Created: 30.12.2012 21:36:18
 *  Author: Michael
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>

#include "EEPROM/EepromController.h"
#include "UART/uart.h"

int main(void)
{
  //*****************************************************************************/
  // EEPROM-Test
  //*****************************************************************************/
  BOOL bResult = FALSE;
  char buffer[50];
  char test;
  uart1_init( UART_BAUD_SELECT(19200,F_CPU) );
  sei();
  
  
//   
//   #define EEPReadByte(addr)         
//   #define EEPWriteByte(addr, val)   eeprom_write_byte((uint8_t *)addr, val)
// 
//   uint16_t addr = 0x10;
// 
//   uart1_puts("\r\nStarte EEPROM-Test...\r\n");
//   
//   uart1_puts("Erstes Lesen: ");
//   test = eeprom_read_byte((uint8_t *)addr);
//   uart1_puts(itoa(test, buffer, 10));
//   
//   uart1_puts("\r\nSchreiben von 0x11223344556677899AA... ");
//   eeprom_write_byte((uint8_t *)addr++, 0x11);
//   eeprom_write_byte((uint8_t *)addr++, 0x22);
//   eeprom_write_byte((uint8_t *)addr++, 0x33);
//   eeprom_write_byte((uint8_t *)addr++, 0x44);
//   eeprom_write_byte((uint8_t *)addr++, 0x55);
//   eeprom_write_byte((uint8_t *)addr++, 0x66);
//   eeprom_write_byte((uint8_t *)addr++, 0x77);
//   eeprom_write_byte((uint8_t *)addr++, 0x88);
//   eeprom_write_byte((uint8_t *)addr++, 0x99);
//   eeprom_write_byte((uint8_t *)addr++, 0xAA);
// 
//   addr = 0x10;
//   uart1_puts("\r\nZweites Lesen: ");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   test = eeprom_read_byte((uint8_t *)addr++);
//   uart1_puts(itoa(test, buffer, 10));
//   uart1_puts("\r\n");
//   
//   uart1_puts("\r\nEnde\r\n");
//   while (1)
//   {
//     ;
//   }

  uart1_puts("Starte EEPROM-Test...\r\n");
  uart1_puts("Lese PIN-Wert aus...\r\n");
  bResult = E2PROM_ReadPinValue(buffer, 50);
  
  if (FALSE == bResult)
  {
    uart1_puts("Konnte keine PIN lesen (1. Durchlauf??)\r\n");
  }
  else
  {
    uart1_puts("Die gelesene PIN lautet: ");
    uart1_puts(buffer);
  }
  
  uart1_puts("Schreibe jetzt PIN 0815\r\n");
  E2PROM_WritePinValue("0815\0");
  uart1_puts("Fertig; jetzt erneut lesen:\r\n");

  bResult = E2PROM_ReadPinValue(buffer, 50);
  
  if (FALSE == bResult)
  {
    uart1_puts("Konnte keine PIN lesen (Jetzt echter Fehler)\r\n");
    uart1_puts(buffer);
  }
  else
  {
    uart1_puts("Die gelesene PIN lautet: ");
    uart1_puts(buffer);
  }
  
  while (1)
  {
    ;
  }
  //*****************************************************************************/
  // EEPROM-Test Ende
  //*****************************************************************************/  
  
  
  
  
  
  while(1)
  {
    //TODO:: Please write your application code 
  }
}